/*
 * Copyright 2011 JBoss, by Red Hat, Inc
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.jboss.errai.ioc.client;

import com.google.gwt.core.client.EntryPoint;
import com.google.gwt.core.client.GWT;
import com.google.gwt.core.client.RunAsyncCallback;
import org.jboss.errai.common.client.api.extension.InitVotes;
import org.jboss.errai.ioc.client.api.Bootstrapper;
import org.jboss.errai.ioc.client.container.CreationalContext;
import org.jboss.errai.ioc.client.container.IOCBeanManagerLifecycle;

public class Container implements EntryPoint {
  @Override
  public void onModuleLoad() {
    boostrapContainer();
  }

  public void boostrapContainer() {
    try {


      InitVotes.waitFor(Container.class);

      final Bootstrapper bootstrapper = GWT.create(Bootstrapper.class);

      System.out.println("Bootstrapepr Generated");

      new IOCBeanManagerLifecycle().resetBeanManager();
      final BootstrapperInjectionContext ctx = bootstrapper.bootstrapContainer();

      System.out.println("Boostrapper Called");

      ctx.getRootContext().finish();

      InitVotes.voteFor(Container.class);


      // return ctx;
    }
    catch (Throwable t) {
      t.printStackTrace();
      throw new RuntimeException("critical error in IOC container bootstrap", t);
    }
  }
}
